unit untMeuServico;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, SvcMgr, Dialogs,
  ExtCtrls;

type
  TServicoExemploActiveDephi = class(TService)
    Timer1: TTimer;
    procedure Timer1Timer(Sender: TObject);
    procedure ServiceExecute(Sender: TService);
  private
    { Private declarations }
  public
    function GetServiceController: TServiceController; override;
    { Public declarations }
  end;

var
  ServicoExemploActiveDephi: TServicoExemploActiveDephi;

implementation

{$R *.DFM}

procedure ServiceController(CtrlCode: DWord); stdcall;
begin
  ServicoExemploActiveDephi.Controller(CtrlCode);
end;

function TServicoExemploActiveDephi.GetServiceController: TServiceController;
begin
  Result := ServiceController;
end;

procedure TServicoExemploActiveDephi.ServiceExecute(Sender: TService);
begin
  Timer1.Enabled := True;
  while not Terminated do
    ServiceThread.ProcessRequests(True);
  Timer1.Enabled := False;
end;

procedure TServicoExemploActiveDephi.Timer1Timer(Sender: TObject);
var
  FileName: String;
  F: TextFile;
begin
  Timer1.Enabled := False;
  try
    FileName := ExtractFilePath(ParamStr(0)) + 'ServicoActiveDelphi.log';
    AssignFile(F, FileName);
    if FileExists(FileName) then
      Append(F)
    else
      Rewrite(F);
    writeln(F, DateTimeToStr(Now));
    CloseFile(F);
  finally
    Timer1.Enabled := True;
  end;
end;

end.
