unit UMutex;

interface

uses
  Classes, Windows, SysUtils;

type
  TMutex = class(TThread)
  private
    { Private declarations }
    procedure ThreadOnTerminated(sender: TObject);
  protected
    procedure Execute; override;
  public

  end;

implementation
uses  UMenu;

{ ThdMutex }

procedure TMutex.ThreadOnTerminated(sender: TObject);
begin
  inc(FrmMenu.FCountThreadTerminated);
  if FrmMenu.FCountThreadTerminated=FrmMenu.FTotalThread then begin
    FrmMenu.lbxThreadFile.Items.AddStrings(FrmMenu.GetFile);
   CloseHandle(FrmMenu.FHMutex);
  end;

end;
procedure TMutex.Execute;
var xcount: Integer;
    xcountprocess:Integer;
    xsl:TStringList;
    xtext:string;
begin
  { Place thread code here }
  FreeOnTerminate:=true;
  OnTerminate:= ThreadOnTerminated;
  if WaitForSingleObject(FrmMenu.FHMutex, Infinite)=wait_Object_0 then begin
    xsl:=FrmMenu.GetFile;
    xcountprocess:=StrToInt(FrmMenu.edtThreadProcess.Text);
    for xcount := 0 to xcountprocess - 1 do begin
      xtext:='ThreadID '+FormatCurr('00',Self.ThreadID) + ' Contador='+FormatCurr('00',xcount);
      xsl.Add(xtext);
      Sleep(1000);
    end;
    FrmMenu.SaveFile(xsl);
  end;
  ReleaseMutex(FrmMenu.FHMutex);

end;



end.
