unit UCriticalSection;

interface

uses
  Classes, Windows, SysUtils;

type
  TCriticalSection = class(TThread)
  private
    { Private declarations }
    procedure ThreadOnTerminated(sender: TObject);
  protected
    procedure Execute; override;
  public

  end;

implementation
uses  UMenu;

{ ThdCriticalSection }

procedure TCriticalSection.ThreadOnTerminated(sender: TObject);
begin
  inc(FrmMenu.FCountThreadTerminated);
  if FrmMenu.FCountThreadTerminated=FrmMenu.FTotalThread then begin
    FrmMenu.lbxThreadFile.Items.AddStrings(FrmMenu.GetFile);
    DeleteCriticalSection(FrmMenu.FCS);
  end;

end;
procedure TCriticalSection.Execute;
var xcount: Integer;
    xcountprocess:Integer;
    xsl:TStringList;
    xtext:string;
begin
  { Place thread code here }
  OnTerminate:= ThreadOnTerminated;
  EnterCriticalSection(FrmMenu.FCS);
  xsl:=FrmMenu.GetFile;
  xcountprocess:=StrToInt(FrmMenu.edtThreadProcess.Text);
  for xcount := 0 to xcountprocess - 1 do begin
    xtext:='ThreadID '+FormatCurr('00',Self.ThreadID) + ' Contador='+FormatCurr('00',xcount);
    xsl.Add(xtext);
    Sleep(1000);
  end;
  FrmMenu.SaveFile(xsl);
  LeaveCriticalSection(FrmMenu.FCS);

end;

end.
